/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.9a Evaluation
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : s4etik
Version : v1.1
Date    : 19.03.2011
Author  : Freeware, for evaluation and non-commercial use only
Company : 
Comments: 
       
 


Chip type               : AT90S2313
AVR Core Clock frequency: 10,000000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 32
*****************************************************/

#include <90s2313.h>
#include <delay.h>

//      9+2  - 11 
//  10      U
//  10  11   U     ,    C  D 
unsigned char buffer[11]={0,1,2,3,4,5,6,7,8,10,3};  



 //  0 1 2 3 4 5 6 7 8 9 U   5141   PB5-8
 unsigned char Simvol [11]={0b11110000,0b11110001, 0b11110010, 0b11110011, 0b11110100, 0b11110101, 0b11110110,
                            0b11110111,0b11111000, 0b11111001,0b11111100 };
 //      9+2+11  1553  PB0-4
 unsigned char Catod [11] = {0b00001111,0b00011111, 0b00101111, 0b00111111, 0b01001111, 0b01011111, 0b01101111,
                             0b01111111,0b10001111, 0b10011111, 0b10101111 };  
                             
/*    4   1     4  1
               1,
    .     ,     
    ,  1  1    1,       1 */                             

// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
// Place your code here

}



// Timer1 output compare interrupt service routine
interrupt [TIM1_COMP] void timer1_comp_isr(void)
 {
  static unsigned char ActivCatod; //       
  unsigned char j;
  PORTB=0b11111111;     //   ,    1. 
  #asm ("nop nop nop nop nop nop nop nop nop  nop")  //  
    
  switch (ActivCatod)                  //     
  {  
     case 0:  PORTB = Catod[0];  break; //   1
       case 1: PORTB = Catod[1];  break; //   2
         case 2: PORTB = Catod[2];  break; //   3
           case 3: PORTB = Catod[3];  break; //   4
             case 4: PORTB = Catod[4];  break; //   5
               case 5: PORTB = Catod[5];  break; //   6
                 case 6: PORTB = Catod[6];  break; //   7
                   case 7: PORTB = Catod[7];  break; //   8
                     case 8: PORTB = Catod[8];  break; //   9 
                       case 9: PORTB = Catod[9];  break; //   10 
                         case 10: PORTB = Catod[10];  break; //   11
                           
    }    
      
     //       
      for( j =0; j <12; j ++)
       { 
         if (j==buffer[ActivCatod]) PORTB &=  Simvol[j];
       }
       
      
             
   ActivCatod ++;                            //        
   if (ActivCatod ==11) ActivCatod = 0;     //   ,    ,  
     
 }


// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTB=0xFF;
DDRB=0xFF;

// Port D initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=1 
PORTD=0x01;
DDRD=0x01;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1 output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x0D;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1H=0x00;
OCR1L=0x10;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: Off
GIMSK=0x40;
MCUCR=0x03;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x40;


// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;

// Global enable interrupts
#asm("sei")

while (1)
      {
      
  }
}